<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Random Image Example</title>
    <style>
        body {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            height: 100vh;
            margin: 0;
        }

        #header {
            position: absolute;
            top: 10px;
            left: 10px;
            z-index: 1000;
        }

        #userSelection {
            padding: 5px;
            font-size: 16px;
        }

        #image-container {
            text-align: center;
            margin-bottom: 20px;
        }

        .button-container {
            display: flex;
            justify-content: center;
            margin-bottom: 20px;
        }

        .button-container button {
            margin: 0 10px;
            padding: 10px;
            font-size: 16px;
        }

        #no-more-images {
            color: red;
        }

        #feedback-form {
            display: flex;
            flex-direction: column;
            align-items: center;
        }

        label {
            font-size: 18px;
            margin-bottom: 5px;
        }

        #comments {
            width: 100%;
            resize: none;
        }
    </style>
</head>
<body>
    <div id="header">
        <select id="userSelection" onchange="changeUser()">
            <option value="user1">User 1</option>
            <option value="user2">User 2</option>
            <option value="user3">User 3</option>
            <option value="user4">User 4</option>
            <option value="user5">User 5</option>
        </select>
    </div>

    <div id="image-container">
    </div>

    <div class="button-container">
        <button onclick="recordFeedback(1)">Correct</button>
        <button onclick="recordFeedback(2)">Partially Correct</button>
        <button onclick="recordFeedback(5)">Incorrect</button>
    </div>

    <div id="feedback-form">
        <label for="comments">Comments:</label>
        <textarea id="comments" name="comments" rows="4" cols="50"></textarea>
    </div>

    <script type="text/javascript">
        var currentUser = document.getElementById('userSelection').value;
        var displayedImages = [];
        var noMorePic = false;
        var imageCount = 0;
        var imageList = [];

        fetch('/current_user', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded',
            },
            body: 'username=' + encodeURIComponent(currentUser),
        })

        fetch('/get_used_images')
        .then(function (response) {
            return response.json();
        })
        .then(function (data) {
            displayedImages = data;
        })
        .catch(function (error) {
            console.error('Error:', error);
        });

        fetch('/number_of_images')
        .then(function (response) {
            return response.json();
        })
        .then(function (data) {
            imageCount = data.length;
            imageList = data.image_files;
        })
        .catch(function (error) {
            console.error('Error:', error);
        });

        function changeUser() {
            currentUser = document.getElementById('userSelection').value;

            fetch('/current_user', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                },
                body: 'username=' + encodeURIComponent(currentUser),
            })

            fetch('/get_used_images')
            .then(function (response) {
                return response.json();
            })
            .then(function (data) {
                displayedImages = data;
                if (displayedImages.length == imageCount) {
                    noMorePic = true;
                    disableButtons();
                    changeImage(); 
                } else {
                    noMorePic = false;
                    enableButtons();
                    changeImage();
                }
            })
            .catch(function (error) {
                console.error('Error:', error);
            });
        }

        function getImageTag() {
            if (displayedImages.length == imageCount) {
                noMorePic = true;
                return '<p id="no-more-images">No more images to show</p>';
            } 

            var randomImage;
            do {
                randomImage = imageList[Math.floor(Math.random() * imageCount)];
                var imageNameWithoutExtension = randomImage.replace(/\.[^/.]+$/, "");
            } while (displayedImages.includes(imageNameWithoutExtension));

            displayedImages.push(imageNameWithoutExtension);
            console.log(displayedImages);

            var testImage = new Image();
            testImage.src = 'static/images/' + randomImage;
            console.log(testImage);

            if (testImage.width > 0) {
                return '<img src="' + testImage.src + '"/>';
            } else {
                return '<img src="' + testImage.src + '" alt="Oh no, the image is broken!"/>';
            }
        }

        function changeImage() {
            var imageContainer = document.getElementById('image-container');
            imageContainer.innerHTML = getImageTag();

            if (noMorePic) {
                disableButtons();
            }
        }

        function disableButtons() {
            var buttons = document.querySelectorAll('.button-container button');
            buttons.forEach(function(button) {
                button.disabled = true;
            });
        }

        function enableButtons() {
            var buttons = document.querySelectorAll('.button-container button');
            buttons.forEach(function(button) {
                button.disabled = false;
            });
        }

        window.addEventListener('load', function () {
            changeImage();
        });

        function recordFeedback(feedbackValue) {
            var comments = document.getElementById('comments').value;
            var imageName = displayedImages[displayedImages.length - 1];

            fetch('/record_data', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                },
                body: 'username=' + encodeURIComponent(currentUser)+ '&score=' + encodeURIComponent(feedbackValue) + '&comments=' + encodeURIComponent(comments) + '&imageName=' + encodeURIComponent(imageName),
            })
            .then(response => response.text())
            .then(data => {
            changeImage();
            document.getElementById('comments').value = '';
            })
            .catch(error => {
            console.error('Error:', error);
            });
        }
    </script>
</body>
</html>